    module pub
    implicit none
    integer hn,N,itermax
    real eta,dk,de,pi,accuarrcy
    parameter(hn = 4,eta = 0.01,dk = 0.1,de = dk,pi = 3.1415926535,itermax = 100,accuarrcy = 1e-5)
    complex,parameter::im = (0.,1.0)  
    complex H00(hn,hn),H01(hn,hn)
    real one(hn,hn) 
!=================================
    real m0,tx,ty,ax,ay
    complex g1(hn,hn),g2(hn,hn),g3(hn,hn) 
    end module pub
!================= PROGRAM START ============================
    program sol
    use pub
    integer i1
    complex GLL(hn,hn),GRR(hn,hn),GBulk(hn,hn)
!======parameter value setting =====
    m0 = 1.5
    tx = 1.0
    ty = 1.0
    ax = 1.0
    ay = 1.0
    ! call openx(0.1)
    ! write(*,*)H00
    ! call inv(H00,H01)
    ! write(*,*)H01
    call main()
    ! call surfgreen_1985(0.1,3.14159,GLL,GRR,Gbulk)
    stop 
    end program sol
!=============================================================================================
    subroutine main()
    use pub
    integer i1
    complex GLL(hn,hn),GRR(hn,hn),GBulk(hn,hn)
    real re1,re2,re3,kx,omega
    open(30,file="spectral.dat")
    do kx = -pi,pi,dk
        do omega = -3,3,de
            ! call surfgreen_1985(omega,kx,GLL,GRR,Gbulk)
            call surfgreen_1985_v2(omega,kx,GLL,GRR,Gbulk)
            re1 = 0
            re2 = 0
            re3 = 0
            do i1 = 1,hn
                re1 = re1 - aimag(GLL(i1,i1))
                re2 = re2 - aimag(GRR(i1,i1))
                re3 = re3 - aimag(GBulk(i1,i1))
            end do
            re1 = re1/pi
            re2 = re2/pi
            re3 = re3/pi
            write(30,999)kx/pi,omega,re1,re2,re3
        end do
        write(30,*)" "
    end do
    close(30)
999 format(10f11.6)
    return
    end subroutine main
!==================================================
    subroutine surfgreen_1985(omega,ky,GLL,GRR,Gbulk)
    use pub
    real omega,ky
    integer iter
    real real_temp
    complex omegac
    complex GLL(hn,hn),GRR(hn,hn),Gbulk(hn,hn)
    complex alphai(hn,hn),betai(hn,hn),epsiloni(hn,hn),epsilons(hn,hn),epsilons_t(hn,hn)
    complex mat1(hn,hn),mat2(hn,hn),g0(hn,hn)
    !------------------------------------------
    ! call openy(ky)
    call openx(ky)
    epsiloni = H00
    epsilons = H00
    epsilons_t = H00
    alphai = H01
    betai = conjg(transpose(H01))
    omegac = omega + im*eta
    do iter = 1,itermax
        call inv(omegac*one- epsiloni,g0)
        mat1 = matmul(alphai,g0)
        mat2 = matmul(betai,g0)
        g0 = matmul(mat1,betai)
        epsiloni = epsiloni + g0
        epsilons = epsilons + g0
        g0 = matmul(mat2,alphai)
        epsiloni = epsiloni + g0
        epsilons_t = epsilons_t + g0
        g0 = matmul(mat1,alphai)
        alphai = g0
        betai = g0
        real_temp = abs(sum(alphai))
        if (real_temp < accuarrcy) then
            exit
        end if
        call inv(omegac*one - epsilons,GLL)
        call inv(omegac*one - epsilons_t,GRR)
        call inv(omegac*one - epsiloni,GBulk)  
    end do
    return
    end subroutine surfgreen_1985
!==================================================
    subroutine surfgreen_1985_v2(omega,ky,GLL,GRR,Gbulk)
    use pub
    real omega,ky
    integer iter
    real real_temp
    complex omegac
    complex GLL(hn,hn),GRR(hn,hn),Gbulk(hn,hn)
    complex alphai(hn,hn),betai(hn,hn),epsiloni(hn,hn),epsilons(hn,hn),epsilons_t(hn,hn)
    complex mat1(hn,hn),mat2(hn,hn),g0(hn,hn)
    !------------------------------------------
    ! call openy(ky)
    call openx(ky)
    epsiloni = H00
    epsilons = H00
    epsilons_t = H00
    alphai = H01
    betai = conjg(transpose(H01))
    omegac = omega + im*eta
    do iter = 1,itermax
        g0 = omegac*one- epsiloni
        call inv2(hn,g0)
        mat1 = matmul(alphai,g0)
        mat2 = matmul(betai,g0)
        g0 = matmul(mat1,betai)
        epsiloni = epsiloni + g0
        epsilons = epsilons + g0
        g0 = matmul(mat2,alphai)
        epsiloni = epsiloni + g0
        epsilons_t = epsilons_t + g0
        g0 = matmul(mat1,alphai)
        alphai = g0
        betai = g0
        real_temp = abs(sum(alphai))
        if (real_temp < accuarrcy) then
            exit
        end if
        GLL = omegac*one - epsilons
        GRR = omegac*one - epsilons_t
        GBulk = omegac*one - epsiloni
        call inv2(hn,GLL)
        call inv2(hn,GRR)
        call inv2(hn,GBulk) 
    end do
    return
    end subroutine surfgreen_1985_v2
!====================================================
    subroutine Pauli()
    use pub
    integer i1
    !=== Kinetic energy
    g1(1,1) = 1
    g1(2,2) = -1
    g1(3,3) = 1
    g1(4,4) = -1
    !====== SOC-x
    g2(1,2) = 1
    g2(2,1) = 1
    g2(3,4) = -1
    g2(4,3) = -1
    !====== SOC-y
    g3(1,2) = -im
    g3(2,1) = im
    g3(3,4) = -im
    g3(4,3) = im
    !---------------
    do i1 = 1,hn
        one(i1,i1) = 1  !单位矩阵
    end do
    return
    end subroutine Pauli
!==========================================================
    subroutine openx(ky)
    use pub
    real ky
    integer m,l,k
    call Pauli()
    H00 = 0
    H01 = 0
    do m = 1,hn
        do l = 1,hn
            H00(m,l) = (m0-ty*cos(ky))*g1(m,l) + ay*sin(ky)*g3(m,l) 

            H01(m,l) = (-tx*g1(m,l) - im*ax*g2(m,l))/2
        end do
    end do
    return
    end subroutine openx
!==========================================================
    subroutine openy(kx)
    use pub
    real kx
    integer m,l,k
    call Pauli()
    H00 = 0
    H01 = 0
    do m = 1,hn
        do l = 1,hn
            H00(m,l) = (m0-tx*cos(kx))*g1(m,l) + ax*sin(kx)*g2(m,l)

            H01(m,l) = (-ty*g1(m,l) - im*ay*g3(m,l))/2
        end do
    end do
    return
    end subroutine openy
!=================================================================
    subroutine inv(matin,matout)
    use pub
    complex,intent(in) :: matin(hn,hn)
    complex:: matout(size(matin,1),size(matin,2))
    real:: work2(size(matin,1))            ! work array for LAPACK
    integer::info2,ipiv(size(matin,1))     ! pivot indices
    ! Store A in Ainv to prevent it from being overwritten by LAPACK
    matout = matin
    ! SGETRF computes an LU factorization of a general M-by-N matrix A
    ! using partial pivoting with row interchanges.
    call CGETRF(hn,hn,matout,hn,ipiv,info2)
    if (info2.ne.0)then
      write(*,*)'Matrix is numerically singular!'
    !   stop
    end if
    ! SGETRI computes the inverse of a matrix using the LU factorization
    ! computed by SGETRF.
    call CGETRI(N,matout,hn,ipiv,work2,hn,info2)
    if (info2.ne.0)then
        write(*,*)'Matrix inversion failed!'
        ! stop
    end if
    return
    end subroutine inv
!=============================================================
    subroutine inv2(ndim,Amat)
    ! ndim is dimension of Amat,the input Amat will be written which is result
    implicit none
    integer,parameter::dp = 8
    integer::i
    integer::info
    integer,intent(in)::ndim   ! in 代表这个值只能是个输入值,不会被改变
!    IPIV   : INTEGER. Array,DIMENSION at least max(1,n). The pivot indices that define
!    the permutation matrix P; row i of the matrix was interchanged with
!    row ipiv(i). Corresponds to the single precision factorization (if info=
!    0 and iter ≥ 0) or the double precision factorization (if info= 0 and
!    iter < 0).
    integer,allocatable::ipiv(:)
    complex(dp),parameter::zone = (1.0d0,0.0d0)
!    Amat  :
!    Overwritten by the factors L and U from the factorization of A = P*L*U;
!    the unit diagonal elements of L are not stored.
!    If iterative refinement has been successfully used (info= 0 and iter≥
!    0),then A is unchanged.
!    If double precision factorization has been used (info= 0 and iter <
!    0),then the array A contains the factors L and U from the factorization
!    A = P*L*U; the unit diagonal elements of L are not stored.
    complex(dp),intent(inout):: Amat(ndim,ndim)
!    Bmat  :
!    Overwritten by the solution matrix X for dgesv,sgesv,zgesv,zgesv.
    complex(dp),allocatable::Bmat(:,:)
    allocate(ipiv(ndim))
    allocate(Bmat(ndim,ndim))
    ipiv=0
    ! unit matrix
    Bmat= (0d0,0d0)
    do i=1,ndim
        Bmat(i,i)= zone
    end do
    call zgesv(ndim,ndim,Amat,ndim,ipiv,Bmat,ndim,info)
    if(info.ne.0)print *,'something wrong with zgesv'
    Amat=Bmat
    return
    end subroutine inv2